/* Moving light   */
#include <GL/glut.h>

static int spin = 160;

void init(void)
{
    glEnable (GL_LIGHTING);
    glEnable (GL_LIGHT0);
}
    
void display (void)
{ 
    GLfloat light0_diffuse[] = {1.0,0.0,0.0,1.0};
    GLfloat light_position[] = {0.0,0.0,1.0,0.0};

    //glClearColor (0.0, 0.2, 0.1, 0.0);
	glClearColor (0.0, 0, 0, 0.0);
    glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    
    glPushMatrix ();
        glRotated ((GLdouble) spin, 0.0, 1.0, 0.0);   
        glLightfv (GL_LIGHT0, GL_DIFFUSE, light0_diffuse);
        glLightfv (GL_LIGHT0, GL_POSITION, light_position);
    glPopMatrix ();
	
	//glLightfv (GL_LIGHT0, GL_DIFFUSE, light0_diffuse);
    glutSolidSphere (1.0, 200, 200);
    glutSwapBuffers ();
}

void reshape(int w, int h)
{
    glViewport (0, 0, (GLsizei) w, (GLsizei) h);
    glMatrixMode (GL_PROJECTION);
    glLoadIdentity ();
    gluPerspective (60.0, (GLfloat) w/(GLfloat) h, 1.0, 20.0);
    glMatrixMode (GL_MODELVIEW);
    glLoadIdentity ();
    gluLookAt(0.0,0.0,4.0, 0.0,0.0,0.0, 0.0,1.0,0.0);
}

void keyboard (unsigned char key, int x, int y)
{
    switch (key) {
        case 'd':
            spin = (spin + 20) % 360;
            glutPostRedisplay ();
            break;
        default:
            break;
    }
}

int main(int argc, char** argv)
{
    glutInit (&argc, argv);
    glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGB);
    glutInitWindowSize (500, 500);
    glutInitWindowPosition (100, 100);
    glutCreateWindow ("Moving Light");
    init ();
    glutDisplayFunc (display);
    glutReshapeFunc (reshape);
    glutKeyboardFunc (keyboard);
    glutMainLoop();
    return 0;
}
